Index: src/org/jboss/ide/eclipse/freemarker/contentassist/CompletionProcessor.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/contentassist/CompletionProcessor.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/contentassist/CompletionProcessor.java	(revision 0)
@@ -0,0 +1,295 @@
+/*
+ * JBoss, a division of Red Hat
+ * Copyright 2006, Red Hat Middleware, LLC, and individual contributors as indicated
+ * by the @authors tag. See the copyright.txt in the distribution for a
+ * full listing of individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.jboss.ide.eclipse.freemarker.contentassist;
+
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.eclipse.core.resources.IResource;
+import org.eclipse.jface.text.BadLocationException;
+import org.eclipse.jface.text.IRegion;
+import org.eclipse.jface.text.ITextSelection;
+import org.eclipse.jface.text.ITextViewer;
+import org.eclipse.jface.text.Region;
+import org.eclipse.jface.text.contentassist.CompletionProposal;
+import org.eclipse.jface.text.contentassist.ICompletionProposal;
+import org.eclipse.jface.text.contentassist.IContentAssistProcessor;
+import org.eclipse.jface.text.source.ISourceViewer;
+import org.eclipse.jface.text.templates.Template;
+import org.eclipse.jface.text.templates.TemplateCompletionProcessor;
+import org.eclipse.jface.text.templates.TemplateContext;
+import org.eclipse.jface.text.templates.TemplateContextType;
+import org.eclipse.jface.text.templates.TemplateException;
+import org.eclipse.swt.graphics.Image;
+import org.jboss.ide.eclipse.freemarker.Plugin;
+import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.jboss.ide.eclipse.freemarker.editor.editorpart.SourceEditor;
+import org.jboss.ide.eclipse.freemarker.model.CompletionDirective;
+import org.jboss.ide.eclipse.freemarker.model.CompletionInterpolation;
+import org.jboss.ide.eclipse.freemarker.model.CompletionMacroInstance;
+import org.jboss.ide.eclipse.freemarker.model.Item;
+import org.jboss.ide.eclipse.freemarker.model.ItemSet;
+import org.jboss.ide.eclipse.freemarker.model.MacroInstance;
+import org.jboss.ide.eclipse.freemarker.template.FreemarkerTemplateContextType;
+import org.jboss.ide.eclipse.freemarker.template.FreemarkerTemplateProposal;
+
+/**
+ * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
+ */
+public class CompletionProcessor extends TemplateCompletionProcessor implements IContentAssistProcessor {
+
+	private SourceEditor editor;
+	
+	
+	public CompletionProcessor (SourceEditor editor) {
+		this.editor = editor;
+	}
+	
+	public ICompletionProposal[] computeCompletionProposals(ITextViewer viewer, int offset) {
+        // Completion proposal for context
+        ICompletionProposal[] result = computeContextCompletionProposals(viewer, offset);
+        // Completion proposal for defined template
+        ICompletionProposal templates[] = templateComputeCompletionProposals(viewer, offset);
+        if(result == null)
+            return templates;
+        if(templates == null)
+        {
+            return result;
+        } else
+        {
+            ICompletionProposal all[] = new ICompletionProposal[result.length + templates.length];
+            System.arraycopy(templates, 0, all, 0, templates.length);
+            System.arraycopy(result, 0, all, templates.length, result.length);
+            return all;
+        }        
+	}
+
+    protected TemplateContextType getContextType(ITextViewer viewer, IRegion region) {
+        return Plugin.getDefault().
+                    getContextTypeRegistry().
+                    getContextType(FreemarkerTemplateContextType.FREEMARKER_CONTEXT_TYPE);
+    }
+
+	protected Image getImage(Template template) {
+		return null;
+	}
+
+	public char[] getCompletionProposalAutoActivationCharacters() {
+		return new char[]{'.', '$', '#', '@', '/', '?', '{'};
+	}
+    
+    /**
+     * Completion proposal for context.
+     * @param viewer
+     * @param offset
+     * @return
+     */
+    private ICompletionProposal[] computeContextCompletionProposals(ITextViewer viewer, int offset) {
+        try {
+            ItemSet directiveSet = editor.getItemSet();
+    
+            Map context = new HashMap();
+            IContextValue[] values = ConfigurationManager.getInstance(editor.getProject()).getContextValues(editor.getFile(), true);
+            for (int i=0; i<values.length; i++) {
+                context.put(values[i].getName(), values[i].getFirstObjectContext().getObject());
+            }
+            
+            Item directive = directiveSet.getSelectedItem(offset);
+            if (null != directive) {
+                return directive.getCompletionProposals(offset, context);
+            }
+            else {
+                // we might be starting something
+                Item item = editor.getItemSet().getPreviousItem(offset);
+                int topOffset = 0;
+                if (null != item) topOffset = item.getRegion().getOffset() + item.getRegion().getLength();
+                // check for directives and macro calls
+                try {
+                    for (int i=offset-1; i>=topOffset; i--) {
+                        char c = editor.getDocument().getChar(i);
+                        if (c == '>' || c == ']') break;
+                        if (c == '<' || c == '[') {
+                            if (editor.getDocument().getLength() > i) {
+                                char c2 = editor.getDocument().getChar(i+1);
+                                if (c2 == '#') {
+                                    CompletionDirective completionDirective = new CompletionDirective(
+                                            i, offset - i, editor.getItemSet(), (ISourceViewer) viewer, (IResource) editor.getFile());
+                                    completionDirective.setItemSet(editor.getItemSet());
+                                    return completionDirective.getCompletionProposals(offset, context);
+                                }
+                                else if (c2 == '@') {
+                                    CompletionMacroInstance completionMacroInstance = new CompletionMacroInstance(
+                                            editor.getDocument().get(i, offset - i), i, editor.getItemSet(), editor.getFile());
+                                    completionMacroInstance.setItemSet(editor.getItemSet());
+                                    return completionMacroInstance.getCompletionProposals(offset, context);
+                                }
+                                else if (c2 == '/') {
+                                    if (editor.getDocument().getLength() < i+3
+                                            || editor.getDocument().getChar(i+2) == ' '
+                                                || editor.getDocument().getChar(i+2) == '\r'
+                                                    || editor.getDocument().getChar(i+2) == '\n') {
+                                        Item stackItem = editor.getItemSet().getPreviousStartItem(offset);
+                                        StringBuffer value = new StringBuffer();
+                                        if (null != stackItem && stackItem instanceof MacroInstance)
+                                            value.append("@");
+                                        else
+                                            value.append("#");
+                                        String name = null;
+                                        if (null != stackItem) name = stackItem.getFirstToken();
+                                        if (null != name)
+                                            value.append(name);
+                                        if (c == '<')
+                                            value.append('>');
+                                        else 
+                                            value.append(']');
+                                        ICompletionProposal completionProposal = new CompletionProposal(
+                                                value.toString(), offset, 0, offset+value.toString().length());
+                                        return new ICompletionProposal[]{completionProposal};
+                                    }
+                                }
+                                else {
+                                    return null;
+                                }
+                            }
+                        }
+                    }
+                }
+                catch (BadLocationException e) {
+                    return null;
+                }
+                // check for interpolations
+                try {
+                    for (int i=offset-1; i>=topOffset; i--) {
+                        char c = editor.getDocument().getChar(i);
+                        if (c == '\n') break;
+                        else if (c == '$') {
+                            if (editor.getDocument().getLength() > i) {
+                                char c2 = editor.getDocument().getChar(i+1);
+                                if (c2 == '{') {
+                                    int j = offset;
+                                    while (editor.getDocument().getLength() > j) {
+                                        char c3 = editor.getDocument().getChar(j);
+                                        if (Character.isWhitespace(c3) || c3 == '(' || c3 == '.' || c3 == ')' || c3 == '}' || c3 == '?') {
+                                            // j = j-1;
+                                            break;
+                                        }
+                                        j++;
+                                    }
+                                    CompletionInterpolation interpolation = new CompletionInterpolation(
+                                            editor.getDocument().get(i, j - i), i, editor.getItemSet(), editor.getFile());
+                                    interpolation.setParentItem(editor.getItemSet().getPreviousStartItem(offset));
+                                    return interpolation.getCompletionProposals(offset, context);
+                                }
+                            }
+                        }
+                    }
+                }
+                catch (BadLocationException e) {
+                    return null;
+                }
+            }
+        }
+        catch (Exception e) {
+            Plugin.log(e);
+        }
+        return null;        
+    }
+    
+    /**
+     * Completion proposal for defined template 
+     * @param viewer
+     * @param offset
+     * @return
+     */
+    private ICompletionProposal[] templateComputeCompletionProposals(ITextViewer viewer, int offset)
+    {
+        ITextSelection selection = (ITextSelection)viewer.getSelectionProvider().getSelection();
+        if(selection.getOffset() == offset)
+            offset = selection.getOffset() + selection.getLength();
+        String prefix = extractPrefix(viewer, offset);
+        if(prefix == null || prefix.length() < 1) 
+            return new ICompletionProposal[0];
+        String indent = ""; //extractIndent(viewer, offset - prefix.length());
+        Region region = new Region(offset - prefix.length(), prefix.length());
+        TemplateContext context = createContext(viewer, region);
+        if(context == null)
+            return new ICompletionProposal[0];
+        context.setVariable("selection", selection.getText());
+        Template templates[] = getTemplates(context.getContextType().getId());
+        if (templates == null)
+            return new ICompletionProposal[0];
+        List matches = new ArrayList();
+        for(int i = 0; i < templates.length; i++)
+        {
+            Template template = prepareTemplate(templates[i], indent);
+            try
+            {
+                context.getContextType().validate(template.getPattern());
+            }
+            catch(TemplateException _ex)
+            {
+                continue;
+            }
+            if(template.getName().startsWith(prefix))
+                matches.add(createFreemarkerProposal(template, context, region, getRelevance(template, prefix)));
+        }
+
+        return (ICompletionProposal[])matches.toArray(new ICompletionProposal[matches.size()]);
+    }   
+    
+    private Template prepareTemplate(Template template, String indent)
+    {
+        if(indent.length() == 0)
+            return template;
+        String newPattern = template.getPattern();
+        StringBuffer sb = new StringBuffer();
+        int i;
+        for(i = 0; i < newPattern.length() - 1; i++)
+        {
+            char c = newPattern.charAt(i);
+            char next = newPattern.charAt(i + 1);
+            if((c == '\n' || c == '\r') && next != '\n' && next != '\r')
+                sb.append(c).append(indent);
+            else
+                sb.append(c);
+        }
+
+        sb.append(newPattern.charAt(i));
+        newPattern = sb.toString();
+        Template t = new Template(template.getName(), template.getDescription(), template.getContextTypeId(), 
+                newPattern, template.isAutoInsertable());
+        return t;
+    }
+    
+    protected ICompletionProposal createFreemarkerProposal(Template template, TemplateContext context, IRegion region, int relevance)
+    {
+           return new FreemarkerTemplateProposal(editor, template, context, region, getImage(template), relevance);
+    }
+    
+    protected Template[] getTemplates(String contextTypeId) {
+        return Plugin.getDefault().getTemplateStore().getTemplates();
+    }
+}
Index: src/org/jboss/ide/eclipse/freemarker/contentassist/SubCompletionProposal.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/contentassist/SubCompletionProposal.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/contentassist/SubCompletionProposal.java	(revision 0)
@@ -0,0 +1,88 @@
+package org.jboss.ide.eclipse.freemarker.contentassist;
+
+import org.eclipse.jface.text.Assert;
+import org.eclipse.jface.text.BadLocationException;
+import org.eclipse.jface.text.IDocument;
+import org.eclipse.jface.text.contentassist.ICompletionProposal;
+import org.eclipse.jface.text.contentassist.IContextInformation;
+import org.eclipse.swt.graphics.Image;
+import org.eclipse.swt.graphics.Point;
+
+public class SubCompletionProposal implements ICompletionProposal {
+
+    private String fDisplayString;
+    private String fReplacementString;
+    private int fReplacementOffset;
+    private int fReplacementLength;
+    private int fCursorPosition;
+    private Image fImage;
+    private IContextInformation fContextInformation;
+    private String fAdditionalProposalInfo;
+    private boolean fRemoveLeftDot;
+    
+    public SubCompletionProposal(String replacementString, int replacementOffset, int replacementLength, int cursorPosition)
+    {
+        this(replacementString, replacementOffset, replacementLength, cursorPosition, null, null, null, null, false);
+    }
+
+    public SubCompletionProposal(String replacementString, int replacementOffset, 
+            int replacementLength, int cursorPosition, Image image, 
+            String displayString, IContextInformation contextInformation, 
+            String additionalProposalInfo, boolean removeLeftDot)
+    {
+        Assert.isNotNull(replacementString);
+        Assert.isTrue(replacementOffset >= 0);
+        Assert.isTrue(replacementLength >= 0);
+        Assert.isTrue(cursorPosition >= 0);
+        fReplacementString = replacementString;
+        fReplacementOffset = replacementOffset;
+        fReplacementLength = replacementLength;
+        fCursorPosition = cursorPosition;
+        fImage = image;
+        fDisplayString = displayString;
+        fContextInformation = contextInformation;
+        fAdditionalProposalInfo = additionalProposalInfo;
+        fRemoveLeftDot = removeLeftDot;
+    }
+
+    public void apply(IDocument document)
+    {
+        try
+        {   if (fRemoveLeftDot) {
+                String content = document.get(fReplacementOffset, 1);
+                if (content.equals("."))
+                    document.replace(fReplacementOffset, 1, "");
+            }
+            document.replace(fReplacementOffset, fReplacementLength, fReplacementString);
+        }
+        catch(BadLocationException _ex) { }
+    }
+
+    public Point getSelection(IDocument document)
+    {
+        return new Point(fReplacementOffset + fCursorPosition, 0);
+    }
+
+    public IContextInformation getContextInformation()
+    {
+        return fContextInformation;
+    }
+
+    public Image getImage()
+    {
+        return fImage;
+    }
+
+    public String getDisplayString()
+    {
+        if(fDisplayString != null)
+            return fDisplayString;
+        else
+            return fReplacementString;
+    }
+
+    public String getAdditionalProposalInfo()
+    {
+        return fAdditionalProposalInfo;
+    }
+}
Index: src/org/jboss/ide/eclipse/freemarker/preferences/FreemarkerTemplatePreferencePage.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/preferences/FreemarkerTemplatePreferencePage.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/preferences/FreemarkerTemplatePreferencePage.java	(revision 0)
@@ -0,0 +1,36 @@
+package org.jboss.ide.eclipse.freemarker.preferences;
+
+import org.eclipse.ui.IWorkbenchPreferencePage;
+import org.eclipse.ui.texteditor.templates.TemplatePreferencePage;
+import org.jboss.ide.eclipse.freemarker.Plugin;
+
+/**
+ * 
+ * Manage Freemarker Template. 
+ * @version 1.0.0 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class FreemarkerTemplatePreferencePage extends TemplatePreferencePage
+    implements IWorkbenchPreferencePage
+{
+
+    public FreemarkerTemplatePreferencePage()
+    {
+        setPreferenceStore(Plugin.getDefault().getPreferenceStore());
+        setTemplateStore(Plugin.getDefault().getTemplateStore());
+        setContextTypeRegistry(Plugin.getDefault().getContextTypeRegistry());
+    }
+
+    protected boolean isShowFormatterSetting()
+    {
+        return false;
+    }
+
+    public boolean performOk()
+    {
+        boolean ok = super.performOk();
+        Plugin.getDefault().savePluginPreferences();
+        return ok;
+    }
+}
Index: src/org/jboss/ide/eclipse/freemarker/preferences/ContextProperties.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/preferences/ContextProperties.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/preferences/ContextProperties.java	(working copy)
@@ -51,7 +51,7 @@
 import org.jboss.ide.eclipse.freemarker.Messages;
 import org.jboss.ide.eclipse.freemarker.Plugin;
 import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
-import org.jboss.ide.eclipse.freemarker.configuration.ContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
 import org.jboss.ide.eclipse.freemarker.dialogs.ContextValueDialog;
 
 public class ContextProperties extends PropertyPage {
@@ -171,11 +171,12 @@
     public void reloadContextValues() {
         try {
             contextValuesTable.removeAll();
-            ContextValue[] values = ConfigurationManager.getInstance(getResource().getProject())
+            IContextValue[] values = ConfigurationManager.getInstance(getResource().getProject())
                     .getContextValues(getResource(), false);
             for (int i = 0; i < values.length; i++) {
                 TableItem item = new TableItem(contextValuesTable, SWT.NULL);
-                String[] arr = { values[i].name, values[i].objClass.getName() };
+                IContextValue contextValue = values[i];
+                String[] arr = { contextValue.getName(), contextValue.getFirstObjectContext().getName() };
                 item.setText(arr);
             }
             editContextValueButton.setEnabled(false);
@@ -236,7 +237,7 @@
             int index = contextValuesTable.getSelectionIndex();
             if (index >= 0) {
                 String key = contextValuesTable.getSelection()[0].getText(0);
-                ContextValue value = ConfigurationManager.getInstance(getResource().getProject()).getContextValue(key,
+                IContextValue value = ConfigurationManager.getInstance(getResource().getProject()).getContextValue(key,
                         getResource(), false);
                 ContextValueDialog dialog = new ContextValueDialog(new Shell(),
                         value, getResource());
@@ -275,9 +276,9 @@
                     if (confirm) {
                         String key = contextValuesTable.getSelection()[0]
                                 .getText(0);
-                        ContextValue value = ConfigurationManager.getInstance(getResource().getProject())
+                        IContextValue contextValue = ConfigurationManager.getInstance(getResource().getProject())
                                 .getContextValue(key, getResource(), false);
-                        ConfigurationManager.getInstance(getResource().getProject()).removeContextValue(value.name,
+                        ConfigurationManager.getInstance(getResource().getProject()).removeContextValue(contextValue.getName(),
                                 getResource());
                         reloadContextValues();
                     }
